library ourads;

import 'dart:async';
import 'dart:io';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:google_mobile_ads/google_mobile_ads.dart';
import 'package:ourads/models/ad_id_interface.dart';
import 'package:ourads/models/test_ad_id.dart';
import 'package:ourads/ad_widgets/our_banner.dart';

import 'models/ad_interface_holder.dart';
part './models/ios_ad_id.dart';
part './ad_widgets/standard_banner.dart';
part './models/android_ad_id.dart';
part './ad_widgets/large_banner.dart';
part './ad_widgets/medium_rectangle.dart';
part './ad_widgets/full_size_banner.dart';
part './ad_widgets/native_ad.dart';
part './ad_widgets/leaderboard.dart';
part './ad_widgets/smart_banner_32.dart';
part './ad_widgets/smart_banner_50.dart';
part './ad_widgets/smart_banner_90.dart';

class OurAds {
  //Calling the constructor
  static final OurAds _inst = OurAds._internal();
 //Calling the constructor
  OurAds._internal();
  //Calling the constructor
  final AdIdInterface _testAdId = TestAdId();
  //Calling the constructor
  late AdIdInterface _adId;
  //Calling the constructor
  static var _isLoaded = false;
  //Calling the constructor
  static InterstitialAd? interstitialAd;
  //Calling the constructor
  static bool _hasOpenAd = false;
  //Calling the constructor
  static AppOpenAd? _appOpenAd;
  //Calling the constructor
  static Completer appOpenAdCompleter = Completer();
  //Function that making the descion to identify the platform
  factory OurAds({AdIdInterface? androidAdId, AdIdInterface? iOSAdId}) {
    if (Platform.isIOS) {
      _inst._adId = kDebugMode ? _inst._testAdId : iOSAdId ?? _inst._testAdId;
    } else if (Platform.isAndroid) {
      _inst._adId =
          kDebugMode ? _inst._testAdId : androidAdId ?? _inst._testAdId;
    }

    return _inst;
  }
  //Function that making the descion to to check the condion on  Open Ads
  //initing the ads
  Future<void> initAds({bool? hasOpenAd}) async {
    //if condition is false then open ads don't work
    _hasOpenAd = hasOpenAd ?? false;

//adding the interface fo Ids
    AdIdInterfaceStore.instance.setadIdInterface = _adId;
    
//Callinf the instance of Goolge Monbile  ads
    await MobileAds.instance.initialize().then((value) async {
      await MobileAds.instance.updateRequestConfiguration(
        RequestConfiguration(testDeviceIds: []),
      );
    });
    //if condition is true then open ads work

    if (hasOpenAd ?? false) {
      await AppOpenAd.load(
        adUnitId: _adId.appOpenId,
        request: AdRequest(),
        adLoadCallback: AppOpenAdLoadCallback(
          onAdLoaded: (AppOpenAd ad) async {
            _appOpenAd = ad;
            appOpenAdCompleter.complete(ad);
          },
          //checking the error
          onAdFailedToLoad: (LoadAdError error) {
            print('AppOpenAd failed to load: $error');
          },
        ),
        orientation: 1,
      );
    }
    _preloadAd();
  }

//Function that making the descion to to check the condion on  Interstital Ads
  static void showInterstitialAd() {
    if (interstitialAd != null && _isLoaded) {
      interstitialAd!.show().then((value) => _preloadAd());
    }
  }
//Function that making the descion to to check the condion on  Open Ads to make them paus eor resume
  static void resumeOpenAppAds() async {
    if (_hasOpenAd) {
      appOpenAdCompleter.future.then((value) {
        _appOpenAd = value;
        _appOpenAd!.show();
      });
    }
  }


//loading  the ads
  static void _preloadAd() async {
    String adId = '';
    try {
      adId = AdIdInterfaceStore.instance.adIdInterface!.interstitialId;
    } catch (e) {
      throw Exception(
          'You did not initialised the object. Please init the object in main function');
    }
    _isLoaded = false;
    await InterstitialAd.load(
      adUnitId: adId,
      request: AdRequest(),
      adLoadCallback: InterstitialAdLoadCallback(
        onAdLoaded: (InterstitialAd ad) {
          interstitialAd = ad;
          _isLoaded = true;
        },
        onAdFailedToLoad: (LoadAdError error) {
          print('InterstitialAd failed to load: $error');
          _isLoaded = false;
        },
      ),
    );
  }
}
